from Globals import DTMLFile, MessageDialog, Persistent, InitializeClass
import OFS
import Acquisition
import AccessControl
from Products import ZCatalog
import base
import issue
import time
import session_manager
import session_folder

manage_add_issue_dealer_form = DTMLFile('issue_dealer_add', globals()) 

javascript = """
function show(id) {
	document.getElementById(id).style.visibility = 'visible';
	return true;
}
    
function hide(id) {
	document.getElementById(id).style.visibility = 'hidden';
	return true;
}
"""

css = """
body {
	background-color: #fff;
	color: #000000;
	font-family: verdana, helvetica, arial, sans-serif;
	font-size: 12px;
        padding: 0px;
        margin: 0px;
}

a {
	text-decoration: none;
	color: #436976;
        background-color: transparent;
}

.green { color: #090; }
.green:hover { color: #6c6; }

.red { color: #900; }
.red:hover { color: #c66; }

.yellow { color: #c90; }
.yellow:hover { color: #fc0; }

a:hover {
	color: #769ca9;
	background-color: transparent;
}

table {
	border: 0px;
}

#main {
	width: 70%;
	float: left;
	padding: 10px;
}

#wide_main {
	width: 98%;
	float: left;
	padding: 10px;
}


#remote {
        border-left: #999 solid 1px;
        border-bottom: #999 solid 1px;
        border-top: #999 solid 1px;        
        background-color: #f7f3f7;
	float: right;
	padding: 5px;
	width: 25%;
	position: relative;
        margin-top: 10px;
        padding-top: 20px;
        padding-left: 10px;
	bottom: 0;
}

.navigationBar {
	margin: 0em; 0em;
	padding: 1px;
	margin: 0px;
        border-bottom: #999 solid 1px;
}

#breadcrumbs {
        background-color: #f7f3f7;
        border-bottom: #999 solid 1px;
        padding: 5px;
	margin: 0em 0em;
        color: #0065ce;
}

.quickMenu {
	padding: 5px;
	float: right;
        color: #0065ce;
        width: auto;
	clear: none;
	vertical-align: middle;
}

.buttons {
	padding: 5px;
	float: left;
	width: auto;
	clear: none;
}

.treeButtons {
	margin: 0px;
	padding: 0px;
	clear: both;
	width: 98%;
}

a.navigation, a.navigation:hover {
        color: #0065ce;
}

div.hidden {
	background-color: #fff;
	position: absolute;
	visibility: hidden;
	border: 1px #999 solid;
	padding: 0.5em;
	z-index: 2;
}

a.button, a.button:hover {
        color: #0065ce;
	font-size: 11px;
        padding: 2px;
}

.disabled {
	color: grey;
}

input[disabled],
textarea[disabled],
option[disabled],
optgroup[disabled],
select[disabled] {
 	color: grey;
}

input {
	font-family: verdana, helvetica, arial, sans-serif;
	font-size: 11px;
	cursor: pointer;
        border: 0px;
        background-color: #fff;
        color: #0065ce;
}

.inputText {
	text-indent: 0.3em;
	color: #000;
        border: #999 solid 1px;
}

.remoteHelp {
}

.remoteInput {
        background-color: #f7f3f7;
        border: 0px;
        margin: 0px;
        padding: 0px;
	font-weight: normal;
}

.remoteTextInput {
        background-color: #f7f3f7;
        border-bottom: #0065ce dotted 1px;
        border-left: 0px;
        border-right: 0px;
        border-top: 0px;
	font-weight: normal;
}

.quickMenuTextInput {
        border-bottom: #0065ce dotted 1px;
        border-left: 0px;
        border-right: 0px;
        border-top: 0px;
	font-weight: normal;
}

.remoteCheckbox {
        background-color: #f7f3f7;
}

textarea {
	font-family: verdana, helvetica, arial, sans-serif;
        border: #999 solid 1px;
        font-size: 0.8em;
}

pre {
	font-family: verdana, helvetica, arial, sans-serif;
}


th {
	text-align: left;
       	vertical-align: top;
}

td {
	text-align: left;
       	vertical-align: top;
}

#session {
	width: 100%;
	margin-top: 15px;
	margin-left: 0px;
	margin-right: 0px;
	padding-top: 10px;
	border-top: 1px solid #999;
}

#copyright {
	background-color: #f7f3f7;
        border-top: #999 solid 1px;
        border-bottom: #999 solid 1px;
	clear: both;
	float: none;
	margin: 4em 0em 1em 0em;
	padding: 5px;
	text-align: center;
}

h1, h2, h3, h4, h5, h6 {
	font-weight: bolder;
}

h1 {
	font-size: 150%;
}

h2 {
	font-size: 140%;
}

h3 {
	font-size: 130%;
}

h4 {
	font-size: 110%;
}

h5 {
	font-size: 80%;
}

h6 {
	font-size: 60%;
}

#message {
	padding: 5px;
        margin-bottom: 5px;
        border: 1px dashed #000;
	background-color: #ffc;
}

/* Session index listing table */

table.session {
	width: 95%;
	border: 1px;
}

table.session tr td {
	padding: 0px;
	margin: 0px;
}

ul.session {
  padding-left: 25px;
  padding-top: 10px;
  margin: 0px;
}

th.field {
  padding: 5px;
  color: #fff;
  background-color: #6386de;
}

tr.first {
  padding-top: 3px;
}

tr.even {}

tr.odd {}
"""

__version__ = '0.8.13'

def manage_add_issue_dealer(self, id, title='', running_tests=0, REQUEST=None):
    """Add an Issue Dealer."""
    self._setObject(id, issue_dealer(id, title))
    # Needed for functional tests
    self._getOb(id).running_tests = running_tests
    if REQUEST is not None:
        return self.manage_main(self, REQUEST)

class issue_dealer(
    OFS.Folder.Folder,
    Persistent,
    Acquisition.Implicit,
    AccessControl.Role.RoleManager,
    base.base,
    session_manager.session_manager,
    ): 
    """Issue Dealer class. 

    An issue dealer contains Issues.
    """

    renaming = 0
    meta_type = 'Issue Dealer'
    size = 500
    deleted = 0

    manage_options = (OFS.Folder.Folder.manage_options[0],) + \
        (
            {'label': 'View',       'action': ''},
            {'label': 'Security',   'action': 'manage_access'},
        ) 

    # Needed for cutting and pasting objects.
    all_meta_types = [
        {'visibility': 'Global',
         'interfaces': [],
         'action': 'manage_add_issue',
         'permission': 'Add Issues',
         'name': 'Issue',
         'product': 'Issue Dealer',
         'instance': ''},
        {'visibility': 'Global',
         'interfaces': [],
         'action': '',
         'permission': 'Use Issue Manager',
         'name': 'Session Folder',
         'product': 'Issue Dealer',
         'instance': ''},
        {'visibility': 'Global',
         'interfaces': [],
         'action': '',
         'permission': 'Use Issue Manager',
         'name': 'Preferences',
         'product': 'Issue Dealer',
         'instance': ''}        
    ]

    security = AccessControl.ClassSecurityInfo()

    security.declareProtected('Use Issue Dealer', 'index_html')
    index_html = DTMLFile('product_index', globals())
    security.declareProtected('Use Issue Dealer', 'manage_add_issue')
    manage_add_issue = issue.manage_add_issue
    security.declareProtected('Use Issue Dealer', 'manage_add_issue_edit')
    manage_add_issue_edit = issue.manage_add_issue_edit

    # Untested
    security.declarePublic('style')
    def style(self):
        """Returns stylesheet data."""
        self.REQUEST.RESPONSE.setHeader('Content-Type', 'text/css')
        return css

    # Untested
    security.declarePublic('javascript')
    def javascript(self):
        """Returns javascript statements."""
        return javascript

    security.declarePrivate('get_issue_dealer')
    def get_issue_dealer(self):
        """Returns self."""
        return self

    security.declarePrivate('get_unique_id')
    def get_unique_id(self):
        """Returns a unique identifier."""
        # This is good enough for now
        integer, float = str(time.time()).split('.')
        return integer + 'X' + float

    indexes = (
      ('title', 'FieldIndex'),
      ('id', 'FieldIndex'),
      ('meta_type', 'FieldIndex'),
      ('bobobase_modification_time', 'FieldIndex'),
      ('type', 'FieldIndex'),
      ('state', 'FieldIndex'),
      ('get_parent_url', 'FieldIndex'),
      ('contents', 'TextIndex'),
      ('get_all_text', 'TextIndex'),
      ('get_title', 'FieldIndex'),
      ('creator', 'FieldIndex'),
      ('owner', 'FieldIndex'),
      ('deleted', 'FieldIndex'),
      ('importance', 'FieldIndex'),
      ('get_state_importance_title_sort', 'FieldIndex'),
      ('get_relative_state', 'FieldIndex'),
      ('get_relative_importance', 'FieldIndex'),
      ('users', 'KeywordIndex'),
      ('owner_', 'FieldIndex'),
      ('path','PathIndex'),
      ('get_level', 'FieldIndex')
    )

    columns = ('contents', 'absolute_url', 'state',
               'type', 'get_title', 'get_number_of_issues',
               'creator', 'owner', 'deleted', 'importance',
               'get_short_url')

    # Tested via setups
    def __init__(self, id, title=''):
        self.id = id
        self.title = title
        ZCatalog.ZCatalog.manage_addZCatalog(self, 'Catalog', 'Issue catalog')
        self.add_indexes()
        self.add_columns()
        self._add_session_folder()

    # Tested via setups
    security.declarePrivate('add_indexes')
    def add_indexes(self):
        """Adds the indexes we're using."""
        catalog = self.Catalog
        for index in self.indexes:
            if not catalog._catalog.indexes.has_key(index[0]):
	        catalog.manage_addIndex(index[0], index[1])

    # Tested via setups
    security.declarePrivate('add_columns')
    def add_columns(self):
        """Adds the columns we're using."""
        catalog = self.Catalog
        for column in self.columns:
            if not catalog._catalog.schema.has_key(column):
                self.Catalog.manage_addColumn(column)

    # Untested
    security.declarePrivate('get_issue_states')
    def get_issue_states(self):
        """Returns a tuple of Issue states."""
        return ('open', 'closed', 'discarded', 'suspended')

    # Untested
    security.declarePrivate('get_issue_types')
    def get_issue_types(self):
        """Returns a tuple of Issue types."""
        return ('alternative', 'goal', 'idea', 'info',
                'problem', 'question', 'solution', 'undefined')

    # Untested
    security.declarePrivate('get_importance_levels')
    def get_importance_levels(self):
        """Returns a sequence of importance levels."""
        return ((0, 'low'), (1, 'normal'), (2, 'high'))

    # Untested
    security.declareProtected('Manage Issue Dealer', 'update_catalog')
    def update_catalog(self, start=0, sleep=0, batch_size=50, update=0):
        """Updates the catalog, reindexing all objects.

        If update is specified, it will be run for each object."""
        try:
            self.on_access()
        except AttributeError:
            self.REQUEST.SESSION['preferences'] = self.get_issue_dealer().objectValues('Preferences')[0].id
        try:
            catalog = self.Catalog._catalog
        except AttributeError:
            ZCatalog.ZCatalog.manage_addZCatalog(self, 'Catalog', 'Issue catalog')
            self.add_indexes()
            self.add_columns()
        start = int(start)
        batch_size = int(batch_size)
        stop = 0
        if start == 0:
            for session in self.sessions.objectValues():
                session.update()
            # Remove the session adding later, FIXME
            self._add_session_folder()
            self._uids = list(catalog.uids.keys())
            self.add_indexes()
            self.add_columns()
            if self.sessions.meta_type != 'Session Folder':
                self._upgrade_session_folder()
        batch = self._uids[start:start+batch_size]
        if not batch:
            stop = 1
            del self._uids
        for uid in batch:
            try:
                object = self.unrestrictedTraverse(uid)
                if int(update):
                    object.update()
                object.index_object()
            except KeyError:
                # It doesn't exist, remove it from the catalog.
                catalog.uncatalog_object(uid)
            except AttributeError:
                # It doesn't inherit from CatalogAwareness.CatalogAware;
                # remove it from the catalog.
                catalog.uncatalog_object(uid)                
        if stop:
            self.REQUEST.RESPONSE.redirect(self.absolute_url())
        else:
            self.REQUEST.RESPONSE.redirect(self.absolute_url() + \
                                           '/update_catalog?start=' + \
                                           str(start + batch_size) + \
                                           '&update=' + str(update))

    # Untested
    security.declarePrivate('get_object')
    def get_object(self, id):
        """Returns the object specified by id."""
        return self.catalog_search(id=id)[0]

    # Untested
    def _upgrade_session_folder(self):
        """Called to upgrade the session folder."""
        session_folder.manage_addSessionFolder(self, id='sessions2')
        self.sessions2.manage_pasteObjects(self.sessions.manage_cutObjects(
            ids=self.sessions.objectIds()))
        self.manage_delObjects(ids=['sessions'])
        self.manage_renameObjects(ids=['sessions2'], new_ids=['sessions'])
        return "Success"

    security.declareProtected('Use Issue Dealer', 'upgrade_session_folder')
    upgrade_session_folder = _upgrade_session_folder

    # Untested
    def _add_session_folder(self):
        if hasattr(self, 'aq_base'):
            if hasattr(self.aq_base, 'sessions'): return
        session_folder.manage_addSessionFolder(self, id='sessions')

    security.declareProtected('Use Issue Dealer', 'redirect_issue')
    def redirect_issue(self, issue):
        """Redirects to the specified Issue."""
        issue = self.get_object(id=issue)
        self.REQUEST.RESPONSE.redirect(issue.absolute_url)

    security.declarePrivate('render_html_title_and_link')
    def render_html_title_and_link(self, size=None, show_session=1):
        """Renders an HTML link."""
        return self.create_hyperlink(self.absolute_url(), self.get_title())

InitializeClass(issue_dealer)
